<?php
// ================================================
// TINYMCE 1.45 PHP WYSIWYG editor control
// ================================================
// Main editor file for CONTENIDO
// ================================================
//								  www.dayside.net
// ================================================
// Author: Martin Horwath, horwath@dayside.net
// TINYMCE 1.45rc1 Fileversion , 2005-06-23 v0.0.5
// ================================================

// include editor config/combat file
include (dirname(__FILE__).DIRECTORY_SEPARATOR."config.php"); // CONTENIDO

// set language for editor
$langs = i18nGetAvailableLanguages();
$editor_lang = $langs[$belang][4];

// editor needs special handling for external_*_list_url
// looks like a tinymce bug, since no uris with http prefix are used correctly -> simple workaround
$editor_baseurl = preg_replace('/^https?:\/\/[^\/]+(.*)$/', '$1', $cfg['path']['wysiwyg_html']);

// all uris are converted to relativ format based on this value
$editor_baseurl_document = $cfgClient[$client]["path"]["htmlpath"];

// name of textarea element
if (isset($type)) {
	$editor_name = "CMS_HTML"; // this should be $type (might be a contenido bug)
} else {
	$editor_name = "content";
}

// editor content stylesheet file
$editor_stylesheet = getEffectiveSetting("wysiwyg","tinymce-stylesheet-file", false);

if ($editor_stylesheet == false)
{
	$editor_stylesheet = "";
} else {
   /* quick and dirty hack */
   if (!preg_match('/^(http|https):\/\/((?:[a-zA-Z0-9_-]+\.?)+):?(\d*)/', $editor_stylesheet)) {
	   if (preg_match('/^\//', $editor_stylesheet)) {
		   $editor_stylesheet = "http://".$_SERVER['HTTP_HOST'].$editor_stylesheet;
	   } else {
		   $editor_stylesheet = $cfgClient[$client]["htmlpath"]["frontend"].$editor_stylesheet;
	   }
   }
}

// enable user defined styles
$editor_styles = getEffectiveSetting("wysiwyg","tinymce-styles", false);
if ($editor_styles) {
	// just to be sure that spaw-styles syntax also works
	$editor_styles = preg_replace('/;$/i', '', str_replace("|", "=", trim($editor_styles)));
}

// editor width and height
$editor_width = getEffectiveSetting("wysiwyg","tinymce-width", "100%");
$editor_height = getEffectiveSetting("wysiwyg","tinymce-height", "480");

switch ($type)
{
	case "CMS_HTML":
			$editor_height = getEffectiveSetting("wysiwyg","tinymce-height-html",$editor_height);
			break;
	case "CMS_HTMLHEAD":
			$editor_height = getEffectiveSetting("wysiwyg","tinymce-height-head",$editor_height);
			break;
}

// toolbar-mode
$editor_toolbar_mode = trim(strtolower(getEffectiveSetting("wysiwyg","tinymce-toolbar-mode", "full")));

// just a proposal
switch ($editor_toolbar_mode)
{
	case "full": /* show all options */
		$editor_buttons_1 = "cut,copy,paste,pastetext,pasteword,separator,search,replace,separator,undo,redo,separator,bold,italic,underline,strikethrough,sub,sup,separator,insertdate,inserttime,preview,separator,styleselect";
		$editor_buttons_2 = "link,unlink,anchor,image,flash,advhr,separator,bullist,numlist,separator,outdent,indent,separator,justifyleft,justifycenter,justifyright,justifyfull,removeformat,separator,forecolor,backcolor,separator,ltr,rtl,separator,fullscreen,visualaid,charmap,cleanup,separator,code";
		$editor_buttons_3 = "tablecontrols,separator,formatselect,fontselect,fontsizeselect";
		$editor_plugins = "table,save,advhr,advimage,advlink,insertdatetime,preview,zoom,flash,searchreplace,print,contextmenu,paste,directionality,fullscreen";
		break;

	case "simple": /* does not show font and table options */
		$editor_buttons_1 = "cut,copy,paste,pastetext,pasteword,separator,search,replace,separator,undo,redo,separator,bold,italic,underline,strikethrough,sub,sup,separator,insertdate,inserttime,preview,separator,styleselect";
		$editor_buttons_2 = "link,unlink,anchor,image,flash,advhr,separator,bullist,numlist,separator,outdent,indent,separator,justifyleft,justifycenter,justifyright,justifyfull,removeformat,separator,forecolor,backcolor,separator,ltr,rtl,separator,visualaid,charmap,cleanup,separator,code";
		$editor_buttons_3 = "";
		$editor_plugins = "advhr,advimage,advlink,insertdatetime,preview,zoom,flash,searchreplace,print,contextmenu,paste,directionality";
		break;

	case "mini": /* minimal options */
		$editor_buttons_1 = "undo,redo,separator,bold,italic,underline,strikethrough,separator,link";
		$editor_buttons_2 = "";
		$editor_buttons_3 = "";
		$editor_plugins = "advlink";
		break;

	default: /* default options */
		$editor_buttons_1 = "undo,redo,separator,bold,italic,underline,strikethrough,separator,link,unlink,anchor,image,flash,advhr,separator,tablecontrols";
		$editor_buttons_2 = "styleselect,separator,bullist,numlist,separator,outdent,indent,separator,justifyleft,justifycenter,justifyright,justifyfull,removeformat,separator,forecolor,backcolor,separator,sub,sup,separator,code";
		$editor_buttons_3 = "";
		$editor_plugins = "table,advhr,advimage,advlink,flash,searchreplace,contextmenu,paste";
}

// xhtml style tags -> <br> or <br />
$editor_xhtml_style = getEffectiveSetting("wysiwyg","tinymce-xhtml-style", false);

// if editor is called from any include.CMS_*.html file use available content from $a_content
if ($a_content[$type][$typenr]) {
	$editor_content = $a_content[$type][$typenr];
	// if not set it is possible to use available content from var $editor_content
}

$editor_content = htmlspecialchars($editor_content);

/*
todo:

-> see editor_template.js
-> create own theme template engine
-> maybe change the way icons are displayed
-> implement fileBrowser

*/

$currentuser = new User;
$currentuser->loadUserByUserID($auth->auth["uid"]);

if ($currentuser->getField("wysi") == 1)
{
?>
<!-- tinyMCE -->
<script language="javascript" type="text/javascript" src="<?php echo $editor_baseurl; ?>jscripts/tiny_mce/tiny_mce.js"></script>
<script language="javascript" type="text/javascript">
		tinyMCE.init({
				mode : "exact",
				elements : "<?php echo $editor_name; ?>",
				language : "<?php echo $editor_lang; ?>",
				width : "<?php echo $editor_width; ?>",
				height : "<?php echo $editor_height; ?>",

				plugins : "<?php echo $editor_plugins; ?>",

				theme : "advanced",
				theme_advanced_buttons1 : "<?php echo $editor_buttons_1; ?>",
				theme_advanced_buttons2 : "<?php echo $editor_buttons_2; ?>",
				theme_advanced_buttons3 : "<?php echo $editor_buttons_3; ?>",

				theme_advanced_toolbar_location : "top",
				theme_advanced_toolbar_align : "left",
				theme_advanced_path_location : "bottom",
				document_base_url : '<?php echo $editor_baseurl_document; ?>',
				content_css : "<?php echo $editor_stylesheet; ?>",
				<?php
if ($editor_styles) {
	echo 'theme_advanced_styles : "'.$editor_styles.'",';
}

?>

				plugin_insertdate_dateFormat : "%Y-%m-%d",
				plugin_insertdate_timeFormat : "%H:%M:%S",

				extended_valid_elements : ""
				                        + "form[accept|accept-charset|action|class|dir<ltr?rtl|enctype|id|lang"
										+ "|method<get?post|name|onclick|ondblclick|onkeydown|onkeypress|onkeyup"
										+ "|onmousedown|onmousemove|onmouseout|onmouseover|onmouseup|onreset|onsubmit"
										+ "|style|title|target],"

										+ "textarea[accesskey|class|cols|dir<ltr?rtl|disabled<disabled|id|lang|name"
										+ "|onblur|onclick|ondblclick|onfocus|onkeydown|onkeypress|onkeyup"
										+ "|onmousedown|onmousemove|onmouseout|onmouseover|onmouseup|onselect"
										+ "|readonly<readonly|rows|style|tabindex|title],"

										+ "input[accept|accesskey|align<bottom?left?middle?right?top|alt"
										+ "|checked<checked|class|dir<ltr?rtl|disabled<disabled|id|ismap<ismap|lang"
										+ "|maxlength|name|onblur|onclick|ondblclick|onfocus|onkeydown|onkeypress"
										+ "|onkeyup|onmousedown|onmousemove|onmouseout|onmouseover|onmouseup|onselect"
										+ "|readonly<readonly|size|src|style|tabindex|title"
										+ "|type<button?checkbox?file?hidden?image?password?radio?reset?submit?text"
										+ "|usemap|value],"

										+ "option[class|dir<ltr?rtl|disabled<disabled|id|label|lang|onclick|ondblclick"
										+ "|onkeydown|onkeypress|onkeyup|onmousedown|onmousemove|onmouseout"
										+ "|onmouseover|onmouseup|selected<selected|style|title|value],"

										+ "select[class|dir<ltr?rtl|disabled<disabled|id|lang|multiple<multiple|name"
										+ "|onblur|onclick|ondblclick|onfocus|onkeydown|onkeypress|onkeyup"
										+ "|onmousedown|onmousemove|onmouseout|onmouseover|onmouseup|size|style"
										+ "|tabindex|title],"

										+ "a[name|href|target|title|onclick],"
										+ "img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name],"
										+ "hr[class|width|size|noshade],"
										+ "font[face|size|color|style],"
										+ "span[class|align|style],"

										+ "ul[class|compact<compact|dir<ltr?rtl|id|lang|onclick|ondblclick|onkeydown"
										+ "|onkeypress|onkeyup|onmousedown|onmousemove|onmouseout|onmouseover"
										+ "|onmouseup|style|title|type],"

										+ "ol[class|compact<compact|dir<ltr?rtl|id|lang|onclick|ondblclick|onkeydown"
										+ "|onkeypress|onkeyup|onmousedown|onmousemove|onmouseout|onmouseover"
										+ "|onmouseup|style|title|type],"

										+ "li[class|compact<compact|dir<ltr?rtl|id|lang|onclick|ondblclick|onkeydown"
										+ "|onkeypress|onkeyup|onmousedown|onmousemove|onmouseout|onmouseover"
										+ "|onmouseup|style|title|type]",

				external_link_list_url : "<?php echo $editor_baseurl."list.php?mode=link&lang=$lang&client=$client"; ?>",
				external_image_list_url : "<?php echo $editor_baseurl."list.php?mode=image&lang=$lang&client=$client"; ?>",
				flash_external_list_url : "<?php echo $editor_baseurl."list.php?mode=flash&lang=$lang&client=$client"; ?>",

				file_browser_callback : "CustomfileBrowserCallBack",
<?php
if (!$editor_xhtml_style) {
?>
				cleanup_callback : "CustomCleanupContent",
<?php
}
?>
				urlconverter_callback : "CustomURLConverter"
		});

		function CustomfileBrowserCallBack(field_name, url, type) {
				// This is where you insert your custom filebrowser logic
				alert("Filebrowser callback: " + field_name + "," + url + "," + type);
		}

		function CustomURLConverter(url, node, on_save) {
				url = TinyMCE.prototype.convertURL(url, node, on_save);
				url = url.replace(/&amp;/g,'&');
				url = url.replace(/&/g,'&amp;');
				return url;
		}

<?php
if (!$editor_xhtml_style) {
?>

		function CustomCleanupContent(type, value) {
				switch (type) {
						case "get_from_editor":
						case "insert_to_editor":
								// Remove xhtml styled tags
								value = value.replace(/[\s]*\/>/g,'>');
								break;
				}

				return value;

		}
<?php
}
?>


</script>
<!-- /tinyMCE -->
<?php
}
?>

<textarea id="<?php echo $editor_name; ?>" name="<?php echo $editor_name; ?>" rows="15" cols="80" style="width: 100%"><?php echo $editor_content; ?></textarea>
